#===============================================================================
# Name   : Script relativo seminrio intervalo de confiana para
#          varincia e desvio padro
# Author : Felipe Frana, Joo Gabriel, Maire Sabrina
# Date   : 16/12/2021 16:32:55
# Aim    : Ilustrar conceitos de intervalo de confiana no R
#===============================================================================
# Reviso e melhoramentos: J.C.Faria (16/12/2021 20:13:52)
#===============================================================================

#. IC(V) e IC(DP)
#.. IC(V)
# Amostra aleatria x = 2.02, 1.94, 2.09, 1.95, 1.98, 2.00, 2.03, 2.04, 2.08, 2.07,
#                       1.99, 1.96, 1.99, 1.95, 1.99, 1.99, 2.03, 2.05, 2.01, 2.03

# Informando o vetor da amostra no R
x <- c(2.02, 1.94, 2.09, 1.95, 1.98, 2.00, 2.03, 2.04, 2.08, 2.07, 
       1.99, 1.96, 1.99, 1.95, 1.99, 1.99, 2.03, 2.05, 2.01, 2.03 )

# Definindo o erro tipo I
alfa <- 5

# Valor do qui_quadrados na tabela com a funo: qchisq
(q_inf <- qchisq((alfa/100)/2,
                 length(x)-1))

(q_sup <- qchisq((alfa/100)/2,
                 length(x)-1,
                 lower=FALSE))

#... Vdeo - bem explicado - sobre a dvida que pode surgir na contruo
#... dos intervalos inferior e superior na diviso dos valores q_sup e q_inf.
# <<https://www.youtube.com/watch?v=zkbPqvzi5Nc&ab_channel=ProfessorGuru>>

# Limite inferior do IC(V)
(ic_inf_v <- (length(x)-1)*var(x)/q_sup)

# Limite superior do IC(V)
(ic_sup_v <- (length(x)-1)*var(x)/q_inf)

#.. Vetor IC(V)
(ic_v <- c(ic_inf_v,
           ic_sup_v))
# Observar diferena no IC(V) do slide. Motivo: arredondamentos nas determinaes no slide!

#.. IC(DP)
# Intervalo de confiana inferior do DP
(ic_inf_sd <- sqrt(ic_inf_v))

# Intervalo de confiana superio do DP
(ic_sup_sd <- sqrt(ic_sup_v))

# Vetor intervalo de confiana do DP
ic_sd <- c(ic_inf_sd,
           ic_sup_sd)
ic_sd


#. Forma mais prtica
#.. IC(V)
# Generalizando para qualquer erro tipo I (alfa):
# Definindo o erro tipo I
alfa <- 5

# Probabilidades
(p <- c(100-(alfa/2),
        alfa/2) / 100)

# IC
ic_v2 <- (length(x)-1) * var(x) / qchisq(p,
                                         length(x)-1)
ic_v2
# Observar diferena no IC(V) do slide. Motivo: arredondamentos nas determinaes no slide!

#.. IC(DP)
ic_sd <- sqrt(ic_v2)
ic_sd
# Observar diferena no IC(DP) do slide. Motivo: arredondamentos nas determinaes no slide!

#. Fazendo uma funo simples para IC(V)
ic_var <- function(x,
                   sig.level=5/100)
{
# Definindo as probabilidades
p <- c(1-(sig.level/2),
       sig.level/2)

# IC
res <- (length(x)-1) * var(x) / qchisq(p,
                                       length(x)-1)
res
}

# Determinando o IC(V) a partir da amostra x
ic_var(x)